#include <stdio.h>
#include <stdlib.h>
#include <regex.h>
#include <string.h>
#include <strings.h>
#include "conversion.h"
#include "misc.h"
#include "config.h"

/* Convert lynx bookmarks to Konqueror bookmarks */
int lynx2konq ()
{
	FILE *file, *out;
	char *str, *str1, *str2, *str3, *str4;
	unsigned int nmatch = 2;
	regex_t preg;
	regmatch_t *matches;

	regcomp (&preg, "href", REG_ICASE);
	file = fopen (LYNX, "r");
	if (file == NULL)
		Error ("Cannot open lynx bookmark file.", 1);
	out = fopen (KONQ, "w");
	str = (char *) malloc (255);
	fputs ("<!DOCTYPE xbel>\n<xbel folded=\"no\" >\n <folder folded=\"yes\" icon=\"bookmark_folder\" >\n", out);
	
	while (fgets (str, 255, file) != NULL)
	{
		matches = (regmatch_t *) malloc (sizeof(regmatch_t)*2);
		
		if (!regexec (&preg, str, nmatch, matches, REG_NOTEOL))
		{
			str1 = (char *) malloc (strlen(&str[matches[0].rm_so]));
			strcpy (str1, &str[matches[0].rm_so]);
			strcpy (str, str1);
			
			str2 = &str[indexi(str, '"')];
			str2++;
			str3 = &str[rindexi(str, '"')];
			str3[0] = '\0';
			str3+=2;
			str4 = &str3[rindexi(str3, '<')];
			str4[0] = '\0';
	
			fprintf (out, "  <bookmark icon=\"www\" href=\"%s\" >\n    <title>%s</title>\n  </bookmark>\n", str2, str3);
			free (str1);
		}
		
		free (matches);
	}
	
	fclose (file);
	fputs (" </folder>\n</xbel>\n", out);
	fclose (out);
	free (str);
	return 0;
}
